SystemOrganization addCategory: #'Smallchange-Test-Web'!
SystemOrganization addCategory: #'Smallchange-Test-Core'!
SystemOrganization addCategory: #'Smallchange-Test-Core-Commands'!

WAComponent subclass: #ModalDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:53'!
renderContentOn: html
	html paragraph: 'Hello!!'.
	html anchor callback: [self answer: 42]; with: 'Close'! !

WAComponent subclass: #ModalTest
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalTest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:52'!
canBeRoot
	^true! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:55'!
callModal: aDialog
	^self call: aDialog! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 20:30'!
renderContentOn: html
	html container: [
		html paragraph: [
		html anchor callback: [answer := self callModal: ModalDialog new]; with: 'Open Dialog'].
		html paragraph: [
			html anchor 
				attributeAt: 'data-toggle' put: 'modal'; 
				attributeAt: 'data-backdrop' put: 'false';
				url: '#xxx'; with: 'Open Modal'.].

		answer ifNotNil: [html heading level: 1; with: answer].
		
	html div class: 'modal'; class: 'hide'; id: 'xxx'; with: 'Foo'].
	html script: ((html jQuery id: 'xxx') call: 'on' with: 'show' with: ((html jQuery id: 'xxx') load html: [ :h | h render: ModalDialog new ] ) asFunction)! !

TestCase subclass: #TestScAccount
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:03'!
newAccount
	^profile newAccount! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:03'!
setUp
	profile := ScProfile name: 'test'.! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:04'!
testTransactionWithAccountSetAppearsinAccountsTransactionList
	| account t |
	account := self newAccount.
	profile addAccount: account.
	t := profile newTransaction
			account: account.
	profile addTransaction: t.
	account transactions should include: t.! !

TestCase subclass: #TestScAddAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testAddAccountAddsToProfile
	[ :profile :account | [ (ScAddAccount profile: profile account: account) do ] 
		should strictly satisfy: [ profile addAccount: account ]] runScenario
! !

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testUndoAddAccountRemovesFromProfile
	[ :profile :account |  |  command | 
		command := (ScAddAccount profile: profile account: account).
		[ command undo] 
			should strictly satisfy: [ profile removeAccount: account ]] runScenario! !

TestCase subclass: #TestScAddPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:18'!
testAddPoolAddsToProfile
	[ :profile :pool | [ (ScAddPool profile: profile pool: pool) do ] 
		should strictly satisfy: [ profile addPool: pool ]] runScenario
! !

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:19'!
testUndoAddPoolRemovesFromProfile
	[ :profile :pool |  |  command | 
		command := (ScAddPool profile: profile pool: pool).
		[ command undo] 
			should strictly satisfy: [ profile removePool: pool ]] runScenario! !

TestCase subclass: #TestScCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:18'!
testScAddAccount
	[ :profile :account | | command |
		[ ( ScAddAccount profile: profile account: account) do]  should strictly satisfy: [
			profile addAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:02'!
testScAddPool
	[ :profile :pool | 
		[ (ScAddPool profile: profile pool: pool) do]  should strictly satisfy: [
			profile addPool: pool ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:48'!
testUndoScAddAccount
	[ :profile :account | | command |
		command := ScAddAccount profile: profile account: account.
		 [command undo ]  should strictly satisfy: [
			profile removeAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:49'!
testUndoScAddPool
	[ :profile :pool | | command |
		command := ScAddPool profile: profile pool: pool.
		[command undo ]  should strictly satisfy: [
			profile removePool: pool ] ] runScenario! !

TestCase subclass: #TestScPool
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 15:59'!
newPool
	^profile newPool! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
setUp
	profile := ScProfile name: 'test'.
	profile addAccount: (ScAccount new name: 'account'; yourself).! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
testDefaultAccountMustExistInProfile
	[self newPool defaultAccount: ScAccount new ] 
		should raise: MbValidationError! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:02'!
testTransactionWithPoolSetAppearsinPoolsTransactionList
	| pool t |
	pool := self newPool.
	profile addPool: pool.
	t := profile newTransaction
			pool: pool.
	profile addTransaction: t.
	pool transactions should include: t.! !

TestCase subclass: #TestScProfile
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 20:44'!
setUp
	profile := ScProfile name: 'test'! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testAddAccount
	[ :account | 
		profile addAccount: account ] runScenario.
	self assert: profile accounts size equals: 1

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddAccountWithSameNameFails
	profile addAccount: (ScAccount new name: 'foo'; yourself).
	self should: [ profile addAccount: (ScAccount new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:10'!
testAddPool
	[ :pool | 
		profile addPool: pool ] runScenario.
	self assert: profile pools size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddPoolWithSameNameFails
	profile addPool: (ScPool new name: 'foo'; yourself).
	self should: [ profile addPool: (ScPool new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemoveAccount
	[ :account | 
		profile addAccount: account.
		profile removeAccount: account ] runScenario.
	self assert: profile accounts isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemovePool
	[:pool |
		profile addPool: pool.
		profile removePool: pool] runScenario.
	self assert: profile pools isEmpty

! !

TestCase subclass: #TestScRecordTransaction
	instanceVariableNames: 'profile account pool transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:28'!
setUp
	profile := ScProfile name: 'Test'.
	account :=  profile newAccount.
	pool := profile newPool.
	profile addAccount: account.
	profile addPool: pool.
	transaction := profile newTransaction
		account: account;
		pool: pool;
		amount: 12.34;
		yourself! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToAccount
	(ScRecordTransaction profile: profile transaction: transaction) do.
	account transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToPool
	(ScRecordTransaction profile: profile transaction: transaction) do.
	pool transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:40'!
testRecordTransactionAddsToProfile
	[ :p | [ (ScRecordTransaction profile: p transaction: transaction) do ] 
		should strictly satisfy: [ p addTransaction: transaction ]] runScenario
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:55'!
testRecordTransactionWithNoPoolSucceeds
	transaction pool: nil.
	(ScRecordTransaction profile: profile transaction: transaction) do.
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromAccount
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	account transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromPool
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	pool transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:09'!
testUndoRecordTransactionRemovesFromProfile
	[ :p |  |  command | 
		command := (ScRecordTransaction profile: p transaction: transaction).
		[ command undo] 
			should strictly satisfy: [ p removeTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScSchedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

TestCase subclass: #TestScTransaction
	instanceVariableNames: 'profile a1 p1 p2 a2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:35'!
newTransaction
	^profile newTransaction! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:54'!
setUp
	profile := ScProfile name: 'test'.
	a1 := (ScAccount new name: 'account'; yourself).
	a2 := (ScAccount new name: 'account2'; yourself).
	p1 := (ScPool new name: 'pool'; yourself).
	p2 := (ScPool new name: 'pool2'; yourself).
	profile addAccount: a1.
	profile addAccount: a2.
	profile addPool: p1.
	profile addPool: p2.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfile
	[self newTransaction account: ScAccount new ] 
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfileSuccess
	[self newTransaction account: profile accounts first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionCanHaveNoPool
	[ self newTransaction pool: nil ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionMustHaveAccount
	[ self newTransaction account: nil ] 
		should raise: MbRequiredFieldError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:30'!
testTransactionPoolMustExistInProfile
	[ self newTransaction pool: ScPool new ]  
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionPoolMustExistInProfileSuccess
	[ self newTransaction pool: profile pools first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:57'!
testTransactionWithBothSourceAndDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithBothSourceAndDestinationAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:54'!
testTransactionWithBothSourceAndDestinationAccountIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isTransfer should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:05'!
testTransactionWithDifferentSourceAndDestinationPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t isIncome should be: true.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:57'!
testTransactionWithOnlyDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsExpense
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isExpense should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlySourceAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:04'!
testTransactionWithSameSourceAndDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:03'!
testTransactionWithSameSourceAndDestinationPoolIsNotAllocation
	| t| 
	t := self newTransaction.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: false! !

ScwComponent subclass: #TestingScwComponent
	instanceVariableNames: 'block announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer
	^announcer! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer: anAnnouncer
	announcer := anAnnouncer.! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:39'!
block: aBlock
	block := aBlock! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:42'!
renderContentOn: html
	html anchor callback: [ block value: self ]; with: 'Go'! !

STTestCase subclass: #TestScwComponent
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:43'!
invokeCallback: aSingleArgumentBlock
	self component block: aSingleArgumentBlock.
	(self lastResponse anchorWithLabel: 'Go') click.! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:02'!
setUp
	super setUp.
	self newApplicationWithRootClass: TestingScwComponent.
	self establishSession.
	announcer := Announcer new.
	self component announcer:  announcer.
	announcer on: ScwModalAnnouncement do: [ :a | | result | a result: (self component call: a component) ]! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:44'!
testCallModalOpensDialog
	self invokeCallback: [ : c | c callModal: WAFormDialog new].
	self assert: (self lastResponse 
		buttonWithValue: 'Ok') notNil! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:06'!
testCallModalReturnsValueOnAnswer
	| value |
	self invokeCallback: [ : c | value := c callModal: WAYesOrNoDialog new].
	(self lastResponse buttonWithValue: 'Yes') click.
	self assert: value ! !
